signature FRiver =
sig
  (* valid_problem rm = rm is a valid problem specification; the first argument
                        of River.river is guaranteed to satisfy this test.
   *)
  val valid_problem : TRiver.rivermap -> bool

  (* river_in f = the rivermap read and parsed from text file f.
   *)
  val river_in : string -> TRiver.rivermap

  (* river_out(f, rm, rps) = The rps solution list of the rm rivermap is written
                             into the f text file.
   *)
  val river_out : string * TRiver.rivermap * TRiver.riverpath list -> unit

  (* solve(i, o) = Reads a problem from the text file i and writes all its solutions
                   into the text file o. Requires a correct implementation of River.river.
                   The result of this function is a string containing the number of
                   solutions and run time statistics.
  *)
  val solve : string * string -> string
end
